=== debian/changelog ===
boinc (8.2.6+dfsg-1) unstable; urgency=medium

  * New upstream version 8.2.6+dfsg
  * Add libzip-dev and nlohmann-json3-dev dependencies, needed for new release
  * Prefer json3.12 instead of json3
  * Bump std-version to 4.7.2, no changes required
  * Drop R^3: no, default now
  * Drop old hacks for unzip/zip build, and stop building unzip tool, removed upstream
  * Drop patch manager_close_no_service_stop, now part of upstream codebase
  * Refresh patches

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 07 Nov 2025 15:52:04 +0100
